package dss160_01
{
   import com.milanpresse.engine.*;
   import com.milanpresse.engine.initmovieclip.*;
   import com.milanpresse.engine.managers.*;
   import com.milanpresse.engine.medias.*;
   import com.milanpresse.engine.timelines.*;
   import com.milanpresse.engine.typeargument.*;
   import com.milanpresse.tools.GlobalesFunctions;
   import flash.display.*;
   import flash.net.*;
   import flash.text.AntiAliasType;
   import flash.text.TextField;
   import flash.text.TextFormat;
   import flash.text.TextFormatAlign;
   
   public class CapsuleAlgo
   {
      private var menu:MediaSwf;
      
      private var menuTimeline:MovieClip;
      
      private var menuTL:Timeline;
      
      private var mainClip:MediaSwf;
      
      private var mainTimeline:MovieClip;
      
      private var _engine:Engine;
      
      private var labelList:Array;
      
      private var _timeline_:TimelineLinear;
      
      private var _timelineManager:TimelineManager;
      
      private var _pauseManager:PauseManager;
      
      private var labelsCallback:Object;
      
      private var firstLabel:String;
      
      private var so:SharedObject;
      
      private var myMc:MovieClip;
      
      private var myIm:InteractiveMovie;
      
      private var ng1Mc:MovieClip;
      
      private var ng1Im:InteractiveMovie;
      
      private var ng2Mc:MovieClip;
      
      private var ng2Im:InteractiveMovie;
      
      private var ng3Mc:MovieClip;
      
      private var ng3Im:InteractiveMovie;
      
      private var navire1Mc:MovieClip;
      
      private var navire1Im:InteractiveMovie;
      
      private var navire2Mc:MovieClip;
      
      private var navire2Im:InteractiveMovie;
      
      private var navire3Mc:MovieClip;
      
      private var navire3Im:InteractiveMovie;
      
      private var compteurMc:MovieClip;
      
      private var compteurIm:InteractiveMovie;
      
      private var activeCase:MovieClip;
      
      private var cesarMc:MovieClip;
      
      private var zoneNavMc:MovieClip;
      
      private var listNavGrille:Array;
      
      private var listNav:Array;
      
      private var maxCoups:int;
      
      private var coups:int;
      
      private var hitNav:Array;
      
      private var totalHitNav:Array;
      
      private var coule:Boolean;
      
      private var activeNav:MovieClip;
      
      private var totalCoule:int;
      
      private var blockClicMc:MovieClip;
      
      private var maxGrille:int = 5;
      
      private var countGrille:int;
      
      private var doneGrille:Array;
      
      private var triche:int;
      
      private var forceGrille:int;
      
      public function CapsuleAlgo(engine:Engine)
      {
         this.labelsCallback = {};
         super();
         this._engine = engine;
         this._engine.playMusic({"code":"MU"});
         this._engine.setSubtitles(this._engine.host.subtitlesOn);
         this._engine.setFrameRate(12);
         this.mainClip = this._engine.showSwf({
            "code":"A_" + this._engine.config.moduleName,
            "parent":this._engine.config.layers["content"]
         });
         this.mainTimeline = this.mainClip.swfContent;
         this._timelineManager = new TimelineManager();
         this._timeline_ = new TimelineLinear(this.mainTimeline,this._engine,this,this._timelineManager,this.labelsCallback);
         this._engine.levelCZ = this._engine.config.layers["content"];
         this.so = SharedObject.getLocal(this._engine.config.rubriqueName,"/");
         this.firstLabel = "_01";
         this.countGrille = 0;
         this.doneGrille = [];
         this.triche = this._engine.config.XmlConfig.Module.Config.triche;
         this.forceGrille = this._engine.config.XmlConfig.Module.Config.forceGrille;
         switch(this.so.data.etatJeux[1])
         {
            case 0:
               this._timeline_.GotoAndPlayUntil({"labelStop":this.firstLabel});
               break;
            case 1:
               this._timeline_.GotoAndPlayUntil({"labelStop":"ATTENTE_J_00"});
               break;
            case 2:
               this._timeline_.GotoAndPlayUntil({"labelStop":"_24"});
         }
      }
      
      public function labelATTENTE_J_00() : void
      {
         this.so.data.etatJeux[1] = 1;
         this.so.flush();
         this.initBTZap();
         this._engine.playComment(new CommentObject({
            "code":"J_00",
            "callback":this._timeline_.nextLabel
         }));
      }
      
      public function labelATTENTE() : void
      {
         this.chooseSetUp();
         this.cesarMc = this.mainTimeline.CESAR_P;
         this.cesarMc.visible = false;
         this.zoneNavMc = this.mainTimeline.ZONE_NAV;
      }
      
      private function chooseSetUp() : void
      {
         var newGrille:int = 0;
         if(this.forceGrille !== 0)
         {
            newGrille = this.forceGrille;
         }
         else
         {
            newGrille = int(GlobalesFunctions.randomInt(1,this.maxGrille));
            this.countGrille += 1;
            if(this.countGrille > this.maxGrille)
            {
               this.countGrille = 1;
               this.doneGrille = [];
            }
            while(this.doneGrille.indexOf(newGrille) !== -1)
            {
               newGrille = int(GlobalesFunctions.randomInt(1,this.maxGrille));
            }
         }
         this.doneGrille.push(newGrille);
         this._timeline_.GotoAndStop(this.mainTimeline.currentFrame + newGrille);
         trace("cf",this.mainTimeline.currentFrame);
         this.initGrid();
      }
      
      private function initGrid() : void
      {
         this.initBTZap();
         this.initNavires();
         this.initCases();
         this.initCompteur();
         this.blockClicMc = this.mainTimeline.BLOCK_CLIC;
         this.blockClicMc.visible = false;
      }
      
      private function initNavires() : void
      {
         this.ng1Mc = this.mainTimeline.NAV_GRILLE_01;
         this.ng1Im = new InteractiveMovie(this.ng1Mc,this._timelineManager);
         this.ng1Im.gotoAndStop("E0");
         this.myMc = this.ng1Mc.ANIM;
         this.myMc.alpha = 0;
         if(this.triche == 1)
         {
            this.myMc.alpha = 0.1;
         }
         this.ng2Mc = this.mainTimeline.NAV_GRILLE_02;
         this.ng2Im = new InteractiveMovie(this.ng2Mc,this._timelineManager);
         this.ng2Im.gotoAndStop("E0");
         this.myMc = this.ng2Mc.ANIM;
         this.myMc.alpha = 0;
         if(this.triche == 1)
         {
            this.myMc.alpha = 0.1;
         }
         this.ng3Mc = this.mainTimeline.NAV_GRILLE_03;
         this.ng3Im = new InteractiveMovie(this.ng3Mc,this._timelineManager);
         this.ng3Im.gotoAndStop("E0");
         this.myMc = this.ng3Mc.ANIM;
         this.myMc.alpha = 0;
         if(this.triche == 1)
         {
            this.myMc.alpha = 0.1;
         }
         this.listNavGrille = [this.ng1Mc,this.ng2Mc,this.ng3Mc];
         this.navire1Mc = this.mainTimeline.NAV_01;
         this.navire1Im = new InteractiveMovie(this.navire1Mc,this._timelineManager);
         this.navire1Im.gotoAndStop("E1");
         this.navire2Mc = this.mainTimeline.NAV_02;
         this.navire2Im = new InteractiveMovie(this.navire2Mc,this._timelineManager);
         this.navire2Im.gotoAndStop("E1");
         this.navire3Mc = this.mainTimeline.NAV_03;
         this.navire3Im = new InteractiveMovie(this.navire3Mc,this._timelineManager);
         this.navire3Im.gotoAndStop("E1");
         this.listNav = [this.navire1Mc,this.navire2Mc,this.navire3Mc];
         this.hitNav = [0,0,0];
         this.totalHitNav = [4,3,2];
      }
      
      private function initCompteur() : void
      {
         this.maxCoups = this._engine.config.XmlConfig.Module.Config.coups;
         this.coups = this.maxCoups;
         this.compteurMc = this.mainTimeline.COMPTEUR;
         this.compteurIm = new InteractiveMovie(this.compteurMc,this._timelineManager);
         this.compteurIm.gotoAndStop("E1");
         this.updateCompteur();
         this.totalCoule = 0;
      }
      
      private function updateCompteur() : void
      {
         var textHolder:MovieClip = null;
         textHolder = this.mainTimeline.LM_COMPTEUR;
         for(var i:int = 0; i < textHolder.numChildren; i++)
         {
            if(textHolder.getChildAt(i).name == "TEXT")
            {
               textHolder.removeChildAt(i);
            }
         }
         var textfield:TextField = new TextField();
         textfield.name = "TEXT";
         textfield.width = textHolder.width;
         textfield.thickness = 0;
         textfield.text = String(this.coups);
         textfield.embedFonts = true;
         textfield.antiAliasType = AntiAliasType.ADVANCED;
         textfield.selectable = false;
         var textFormat:TextFormat = new TextFormat("Arcena",55,4133397,null,null,null,null,null,TextFormatAlign.CENTER,null,null,null,1);
         textfield.setTextFormat(textFormat);
         textHolder.addChild(textfield);
      }
      
      private function initCases() : void
      {
         var i:int;
         var animMc:MovieClip = null;
         for(i = 1; i <= 49; i++)
         {
            this.myMc = this.mainTimeline["CASE_" + this.G2D(i)];
            this.myIm = new InteractiveMovie(this.myMc,this._timelineManager);
            this.myIm.gotoAndStop(1);
            this.myIm.active();
            animMc = this.myMc.ANIM;
            animMc.visible = false;
            this.myIm.mc.onRollOver = function(p:Object):void
            {
            };
            this.myIm.mc.onRollOut = function(p:Object):void
            {
            };
            this.myIm.mc.onPress = function(p:Object):void
            {
               blockClicMc.visible = true;
               var hit:int = 0;
               for(var i:int = 1; i <= 3; i++)
               {
                  if(Boolean(this.hitTestObject(listNavGrille[i - 1])))
                  {
                     hit = i;
                     this.desactive();
                     this.dead = true;
                     this.gotoAndStop(1);
                     myMc = this.ANIM;
                     myMc.visible = true;
                     activeCase = myMc;
                     myIm = new InteractiveMovie(myMc,_timelineManager);
                     myIm.gotoAndPlayUntilTheEnd(1,suiteHit);
                     _engine.playNoise(new NoiseObject({"code":"B_BOUM"}));
                     hitNav[i - 1] += 1;
                     if(hitNav[i - 1] == totalHitNav[i - 1])
                     {
                        coule = true;
                        activeNav = listNavGrille[i - 1];
                        listNav[i - 1].gotoAndStop("E2");
                        _engine.playNoise(new NoiseObject({"code":"B_EXPLOSE"}));
                     }
                     else
                     {
                        coule = false;
                     }
                     break;
                  }
               }
               if(hit == 0)
               {
                  this.desactive();
                  this.gotoAndStop(2);
                  myMc = this.ANIM;
                  activeCase = myMc;
                  myIm = new InteractiveMovie(myMc,_timelineManager);
                  myIm.gotoAndPlayUntilTheEnd(1,suiteRate);
                  _engine.playNoise(new NoiseObject({"code":"B_PLOUF"}));
               }
               coups -= 1;
               updateCompteur();
            };
            this.myIm.activeMC();
         }
      }
      
      private function suiteRate() : void
      {
         this.activeCase.gotoAndStop("E2");
         this._engine.playNoise(new NoiseObject({"code":"B_RATE"}));
         if(this.coups == 0)
         {
            this._engine.playComment(new CommentObject({
               "code":"J_ECHEC",
               "callback":this.suiteEchec
            }));
            this.compteurMc.gotoAndStop("E2");
         }
         else
         {
            this.blockClicMc.visible = false;
         }
      }
      
      private function suiteEchec() : void
      {
         this.coups = this.maxCoups;
         this.updateCompteur();
         this.navire1Mc.gotoAndStop("E1");
         this.navire2Mc.gotoAndStop("E1");
         this.navire3Mc.gotoAndStop("E1");
         this._timeline_.GotoAndPlayUntil({"labelStop":"ATTENTE"});
      }
      
      private function suiteHit() : void
      {
         this.activeCase.gotoAndStop("E2");
         this._engine.playNoise(new NoiseObject({"code":"B_TOUCHE"}));
         if(this.coule)
         {
            this.totalCoule += 1;
            this.zapCases();
            this.activeNav.gotoAndStop("E1");
            this.myMc = this.activeNav.ANIM;
            this.myIm = new InteractiveMovie(this.myMc,this._timelineManager);
            this.myIm.gotoAndPlayUntilTheEnd(1,this.couler);
            this._engine.playNoise(new NoiseObject({"code":"B_COULE"}));
         }
         else if(this.coups == 0)
         {
            this._engine.playComment(new CommentObject({
               "code":"J_ECHEC",
               "callback":this.suiteEchec
            }));
            this.compteurMc.gotoAndStop("E2");
         }
         else
         {
            this.blockClicMc.visible = false;
         }
      }
      
      private function couler() : void
      {
         this.activeNav.gotoAndStop("E2");
         if(this.totalCoule == 3)
         {
            this.so.data.etatJeux[1] = 2;
            this.so.flush();
            this._engine.playComment(new CommentObject({
               "code":"J_GAGNE",
               "callback":this.suiteRecit
            }));
         }
         else if(this.coups == 0)
         {
            this._engine.playComment(new CommentObject({
               "code":"J_ECHEC",
               "callback":this.suiteEchec
            }));
            this.compteurMc.gotoAndStop("E2");
         }
         else
         {
            this.blockClicMc.visible = false;
         }
      }
      
      private function suiteRecit() : void
      {
         this._timeline_.GotoAndPlayUntil({"labelStop":"WAIT_transition"});
      }
      
      private function zapCases() : void
      {
         for(var i:int = 1; i <= 49; i++)
         {
            this.myMc = this.mainTimeline["CASE_" + this.G2D(i)];
            if(Boolean(this.myMc.dead))
            {
               if(this.myMc.hitTestObject(this.activeNav))
               {
                  this.myMc.visible = false;
               }
            }
         }
      }
      
      private function initBTZap() : void
      {
         this.myMc = this.mainTimeline.BT_ZAP;
         this.myIm = new InteractiveMovie(this.myMc,this._timelineManager);
         this.myIm.gotoAndStop(1);
         this.myIm.mc.onRollOver = function(p:Object):void
         {
            _engine.playNoise(new NoiseObject({"code":"B_ZAP"}));
            _engine.showIB({
               "id":"IB_ZAP",
               "x":this.x,
               "y":this.y + 25
            });
         };
         this.myIm.mc.onRollOut = function(p:Object):void
         {
            _engine.stopNoise(new NoiseObject({"code":this.pNoiseRoll}));
            _engine.hideIB();
         };
         this.myIm.mc.onPress = function(p:Object):void
         {
            so.data.etatJeux[1] = 2;
            so.flush();
            cesarMc.visible = true;
            navire1Mc.visible = false;
            navire2Mc.visible = false;
            navire3Mc.visible = false;
            zoneNavMc.visible = false;
            _engine.stopNoise(new NoiseObject({"code":this.pNoiseRoll}));
            _engine.playComment(new CommentObject({
               "code":"J_PASSE",
               "callback":suiteZap
            }));
         };
         this.myIm.activeMC();
      }
      
      public function suiteZap() : void
      {
         this._timeline_.GotoAndPlayUntil({"labelStop":"WAIT_transition"});
      }
      
      public function G2D(value:int) : String
      {
         return GlobalesFunctions.gimme2digits(value);
      }
      
      private function goNextModule() : void
      {
      }
      
      public function endMODULE() : void
      {
         trace("fin du module");
         this.so.data.ecranEnCours = 2;
         this._engine.host.changeModule({"numMod":this.so.data.ecranEnCours});
      }
      
      public function sleep() : void
      {
         this._pauseManager = new PauseManager(this._engine,this._timelineManager);
         this._pauseManager.sleepMovie(this.mainTimeline);
      }
      
      public function wake() : void
      {
         if(this._pauseManager != null)
         {
            this._pauseManager.wakeMovie(this.mainTimeline);
         }
      }
      
      public function destroy() : void
      {
         this._engine.stopAllSounds();
         this._timeline_.kilListeners();
      }
   }
}

